<TeXmacs|1.0.7.20>

<style|<tuple|beamer|vdh|tmdoc-markup>>

<\body>
  <\hide-preamble>
    <assign|pt|<macro|<math-times|<superpose|+|\<times\>>>>>

    \;
  </hide-preamble>

  <screens|<\shown>
    <\with|par-mode|center>
      <\strong>
        <with|font-base-size|14|Towards semantic mathematical editing>
      </strong>
    </with>

    <\with|par-mode|center>
      <tabular*|<tformat|<table|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|>|<cell|<block*|<tformat|<cwith|1|1|1|1|cell-background|white>|<cwith|1|1|1|1|cell-lsep|1em>|<cwith|1|1|1|1|cell-rsep|1em>|<cwith|1|1|1|1|cell-bsep|1em>|<cwith|1|1|1|1|cell-tsep|1em>|<table|<row|<cell|<image|texmacs-chip.png|0.6w|0.6h||>>>>>>>|<cell|>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|>|<cell|Joris
      van der Hoeven, Palaiseau 2011>|<cell|>>|<row|<cell|>|<cell|<verbatim|http://www.<TeXmacs*>.org>>|<cell|>>>>>
    </with>

    \;
  </shown>|<\hidden>
    <tit|Three levels of mathematical documents>

    <\description>
      <vspace*|0.5fn><item*|Informal mathematics>

      <em|Software>: text editors, mathematical user interfaces

      <switch|<\shown>
        <em|Formats>: <LaTeX>, presentation <name|MathML>
      </shown>|<\hidden>
        <em|Example>: <verbatim|$a(b+c)$><htab|5mm><greyed|<LaTeX>>
      </hidden>|<\hidden>
        <em|Example>:<htab|5mm><light|Presentation <name|MathML>>

        <\indent>
          <\small>
            <\with|par-par-sep|0fn>
              <\verbatim>
                \<less\>mrow\<gtr\>

                \ \ \<less\>mi\<gtr\>a\<less\>/mi\<gtr\>
                \<less\>mo\<gtr\>&InvisibleTimes;\<less\>/mo\<gtr\>

                \ \ \<less\>mo\<gtr\>(\<less\>/mo\<gtr\>
                \<less\>mi\<gtr\>b\<less\>/mi\<gtr\>
                \<less\>mo\<gtr\>+\<less\>/mo\<gtr\>
                \<less\>mi\<gtr\>c\<less\>/mi\<gtr\>
                \<less\>mo\<gtr\>)\<less\>/mo\<gtr\>

                \<less\>/mrow\<gtr\>
              </verbatim>
            </with>
          </small>
        </indent>
      </hidden>|<\hidden>
        <em|Example>: <inactive*|a*<around|(|b+c|)>><htab|5mm><light|<TeXmacs>>
      </hidden>>

      <vspace*|0.5fn><item*|Syntactically correct documents>

      <em|Software>: computer algebra systems, scientific computation systems

      <switch|<\shown>
        <em|Formats>: content <name|MathML>, software specific languages
      </shown>|<\hidden>
        <em|Example>:<htab|5mm><light|Content <name|MathML>>

        <\indent>
          <\small>
            <\with|par-par-sep|0fn>
              <\verbatim>
                \<less\>apply\<gtr\>

                \ \ \<less\>times/\<gtr\>

                \ \ \<less\>ci\<gtr\>a\<less\>ci\<gtr\>

                \ \ \<less\>apply\<gtr\>

                \ \ \ \ \<less\>plus/\<gtr\>
                \<less\>ci\<gtr\>b\<less\>/ci\<gtr\>
                \<less\>ci\<gtr\>c\<less\>/ci\<gtr\>

                \ \ \<less\>/apply\<gtr\>

                \<less\>/apply\<gtr\>
              </verbatim>
            </with>
          </small>
        </indent>
      </hidden>|<\hidden>
        <em|Example>: <verbatim|(* a (+ b c))><htab|5mm><light|Scheme>
      </hidden>>

      <vspace*|0.5fn><item*|Semantically correct documents>

      <em|Software>: automatic theorem provers/checkers

      <switch|<\shown>
        <em|Formats>: <name|OpenMath>, <name|OMDoc>, software specific
        languages
      </shown>|<\hidden>
        <em|Example>: <math|a*<around*|(|b+c|)>>, where
        <math|a,b,c\<in\>\<bbb-Z\>> and <math|+,\<cdot\>:\<bbb-Z\><rsup|2>\<rightarrow\>\<bbb-Z\>>
      </hidden>>
    </description>
  </hidden>|<\hidden>
    <tit|The challenge>

    <\description>
      <vspace*|0.5fn><item*|General purpose user interfaces>

      Presentation oriented, no syntactic or semantic
      correctness.<vspace|0.5fn>

      <switch|<\shown>
        <\pastel>
          <item*|Improved general purpose interfaces>

          Presentation oriented interface <em|while> enforcing syntactic
          correctness<vspace|0.5fn>
        </pastel>
      </shown>|<\hidden>
        <item*|Improved general purpose interfaces>

        Presentation oriented interface <em|while> enforcing syntactic
        correctness<vspace|0.5fn>
      </hidden>>

      <item*|Interfaces for special systems>

      May enforce syntactic or semantic correctness, application specific
    </description>
  </hidden>|<\hidden>
    <tit|Possible approaches>

    <\with|par-par-sep|0.3333fn>
      <\description>
        <unroll|<\shown>
          <vspace*|0.5fn><item*|User friendly extreme>

          Rely on intelligent software to make sense out of presentation
          markup.
        </shown>|<\hidden*>
          <vspace*|0.5fn><item*|Programmer friendly extreme>

          Let the user provide the explicit content markup.
        </hidden*>|<\hidden*>
          <vspace*|0.5fn><item*|Compromise>

          <\itemize>
            <\with|par-par-sep|0fn>
              <item>Make as much sense out of presentation markup as
              possible:

              <math|\<rightarrow\>> Automatic upgrading

              <math|\<rightarrow\>> Automatic syntax correction

              <math|\<rightarrow\>> Packrat parsing
            </with>

            <item>Provide markup for correcting the default interpretation,
            when needed.
          </itemize>
        </hidden*>|<\hidden*>
          <vspace*|0.5fn><item*|Central technique>

          <\with|par-par-sep|0fn>
            <math|\<rightarrow\>> Presentation oriented interface

            <math|\<rightarrow\>> Background converter presentation markup
            <math|\<rightsquigarrow\>> content markup
          </with>
        </hidden*>>
      </description>
    </with>

    \;
  </hidden>|<\hidden>
    <tit|Common ambiguities>

    <\with|par-par-sep|0.3333fn>
      <\fold-back>
        <\description>
          <unroll|<\shown>
            <vspace*|0.5fn><item*|Invisible operators>

            <\summarized-plain>
              <em|Fundamental ambiguity>:<space|1em><math|a*<around*|(|b+c|)>><space|1em>versus<space|1em><math|f<around*|(|x+y|)>>
            <|summarized-plain>
              <\itemize>
                <item>Invisible separators:
                <math|A=<around|(|a<rsub|i\<nocomma\>j>|)>>

                <item>Invisible addition: <math|17\<noplus\><frac*|3|8>>

                <item>Invisible ``wildcards'': <math|\<nosymbol\>+1> (also
                denoted by <math|<op|\<cdot\>>+1>)

                <item>Invisible ellipses:
                <math|<matrix|<tformat|<table|<row|<cell|a<rsub|1\<nocomma\>1>>|<cell|\<cdots\>>|<cell|a<rsub|1\<nocomma\>n>>>|<row|<cell|\<vdots\>>|<cell|>|<cell|\<vdots\>>>|<row|<cell|a<rsub|n\<nocomma\>1>>|<cell|\<cdots\>>|<cell|a<rsub|n\<nocomma\>n>>>>>>>

                <item>Invisible zeros: <math|<matrix|<tformat|<table|<row|<cell|a<rsub|1\<nocomma\>1>>|<cell|>|<cell|>>|<row|<cell|>|<cell|\<ddots\>>|<cell|>>|<row|<cell|>|<cell|>|<cell|a<rsub|n\<nocomma\>n>>>>>>>

                <item>Invisible brackets, for forced matching if we want to
                omit a bracket
              </itemize>
            </summarized-plain>
          </shown>|<\hidden*>
            <vspace*|0.5fn><item*|Vertical bars>

            <\summarized-plain>
              <em|Example>:<space|1em><math|<around*|{|a\<in\>\<bbb-N\>\|17\<divides\>a|}>>
            <|summarized-plain>
              <\itemize>
                <item>Brackets: absolute values <math|<around|\||x|\|>> or
                ``ket'' notation <math|<around|\<langle\>|A|\|>>

                <item>``Such that'' separators:
                <math|<around|{|a\<in\>X\|a\<geqslant\>0|}>>

                <item>``Divides'' predicate: <math|11\<divides\>1001>

                <item>Separators: <math|<around|\<langle\>|a<rsub|1><around|\||\<cdots\>|\|>a<rsub|n>|\<rangle\>>>.

                <item>Restricting domains or images:
                <math|\<varphi\>\|<rsub|D>>, <math|\<varphi\>\|<rsup|I>>.
              </itemize>
            </summarized-plain>
          </hidden*>|<\hidden*>
            <vspace*|0.5fn><item*|Ponctuation>

            <\summarized-plain>
              <em|Example>:<space|1em><math|\<mathlambda\>P\<point\>3.14+<math-ordinary|P<space|-0.6spc>.x>>
            <|summarized-plain>
              <\itemize>
                <item>Commas: <math|f<around|(|x,y|)>>,
                <math|3\<comma\>14159\<cdots\>>,
                <math|1\<comma\>000\<comma\>000>

                <item>Periods: <math|3.14159>, <math|\<lambda\> x.x<rsup|2>>,
                data access <math|a.b>, period.

                <item>Semicolons: <math|<around|{|x\<in\>X:x\<geqslant\>0|}>>,
                <math|P=<around*|(|x:y:z|)>\<in\>\<bbb-P\><rsup|2>>,
                <math|a:<math-ss|Int>>.

                <item>Moreover, in the formula

                <\equation>
                  a<rsup|2>+b<rsup|2>=c<rsup|2>,
                </equation>

                ponctuation is used in the traditional, non-mathematical way.
              </itemize>
            </summarized-plain>
          </hidden*>|<\hidden*>
            <vspace*|0.5fn><item*|Miscellaneous homoglyphs>

            <\summarized-plain>
              <em|Example>:<space|1em><math|a\<leqslant\>b\<wedge\>a+b\<leqslant\><big|int><rsub|\<cal-V\>>f<around*|(|x,y|)>*\<mathd\>x\<exterior\>\<mathd\>y>
            <|summarized-plain>
              <\itemize>
                <item>Backslash <math|\\>: separator or ``subtraction'' of
                sets <math|X\<setminus\>Y>

                <item>Dot <math|<op|\<cdot\>>>: multiplication
                <math|\<b-a\>\<cdot\>\<b-b\>> or wildcard
                <math|<around|\||<op|\<cdot\>>|\|><rsub|p>>

                <item>Wedge <math|\<wedge\>>: logical and <math|P\<wedge\>Q>
                or exterior product <math|\<mathd\>x\<exterior\>\<mathd\>y>.
              </itemize>
            </summarized-plain>
          </hidden*>|<\hidden*>
            <vspace*|0.5fn><item*|Good news>

            <em|THAT IS ABOUT IT!><space|1em><greyed|...but inconsistent
            support in Unicode>
          </hidden*>>
        </description>
      </fold-back>
    </with>
  </hidden>|<\hidden>
    <tit|Syntax correction>

    <\description>
      <\with|par-par-sep|0.3333fn>
        <item*|Invisible tag correction>

        <\small>
          Breaks: <with|color|#6060a0|<verbatim|<with|color|dark
          grey|\\begin{math}>a+<with|color|#c08080|\\end{math}><with|color|#c08080|\\begin{math}>b<with|color|dark
          grey|\\end{math}>>>.

          Redundancies I: <with|color|#6060a0|<verbatim|<with|color|dark
          grey|\\begin{math}>a+<with|color|#c08080|\\begin{math}>b<with|color|#c08080|\\end{math}><with|color|dark
          grey|\\end{math}>>>.

          Redundancies II: <with|color|#6060a0|<verbatim|<with|color|dark
          grey|\\begin{math}><with|color|#c08080|\\text{>hi<with|color|#c08080|}><with|color|dark
          grey|\\end{math}>>>.
        </small>
      </with>

      <\with|par-par-sep|0.3333fn>
        <item*|Bracket matching>Match in decreasing order of likeliness

        <\small>
          <em|Example>: <math|f<around|(|<around|\||x|\|>|)>=g<around|(|<around|\||x|\|>+<around|\||y|\|>|)>>

          Match <math|<around*|(|<around*|\||x|\|>|)>> and
          <math|<around*|(|<around*|\||x|\|>+<around*|\||y|\|>|)>> at an
          early stage.

          Match <math|<around*|\||x|\|>>, <math|<around*|\||x|\|>> and
          <math|<around*|\||y|\|>> at a later stage, with higher security
        </small>
      </with>

      <item*|Bracket motion><verbatim|<with|color|#6060a0|Let
      <with|color|dark grey|$>y=f<with|color|#c08080|(>x<with|color|dark
      grey|$><with|color|#c08080|)>.>> <math|\<rightsquigarrow\>>
      <with|color|#6060a0|<verbatim|Let <with|color|dark
      grey|$>y=f<with|color|#c08080|(>x<with|color|#c08080|)><with|color|dark
      grey|$>.>>

      <item*|Superfluous invisible removal><verbatim|<with|color|#6060a0|<with|color|dark
      grey|$>\\frac{a<with|color|#c08080|\\*>}{b}<with|color|dark grey|$>>>
      <math|\<rightsquigarrow\>> <verbatim|<with|color|#6060a0|<with|color|dark
      grey|$>\\frac{a}{b}<with|color|dark grey|$>>>

      <item*|Missing invisible insertion><verbatim|<with|color|#6060a0|<with|color|dark
      grey|$>2x<with|color|dark grey|$>>> <math|\<rightsquigarrow\>>
      <with|color|#6060a0|<verbatim|<with|color|dark
      grey|$>2<with|color|#60a060|\\*>x<with|color|dark grey|$>>>,
      <verbatim|<with|color|#6060a0|<with|color|dark
      grey|$>Lf<with|color|dark grey|$>>> <math|\<rightsquigarrow\>>
      <with|color|#6060a0|<verbatim|<with|color|dark
      grey|$>L<with|color|#60a060|\\_>f<with|color|dark grey|$>>>.

      <item*|Homoglyph substitution><math|<with|color|#6060a0|a:=b>>
      <math|\<rightsquigarrow\>> <math|<with|color|#6060a0|a\<assign\>b>>

      <item*|Miscellaneous corrections><verbatim|<with|color|#6060a0|<with|color|dark
      grey|$>a^<with|color|#c08080|{^>x<with|color|#c08080|}><with|color|dark
      grey|$>>> <math|\<rightsquigarrow\>>
      <verbatim|<with|color|#6060a0|<with|color|dark
      grey|$>a^x<with|color|dark grey|$>>>
    </description>
  </hidden>|<\hidden>
    <tit|Experimental results>

    <switch|<\shown>
      <\with|par-par-sep|0fn>
        <strong|BPR>: Algorithms in Real Algebraic Geometry (Basu, Pollack,
        Roy)

        <strong|COL>: Collection of class notes (Evan Chou)

        <strong|LN>: Transseries and Real Differential Algebra (vdH)
      </with>

      <unroll|<\shown>
        <big-table*|<block|<tformat|<cwith|2|4|2|8|cell-halign|r>|<cwith|5|5|2|8|cell-halign|r>|<cwith|1|1|2|8|cell-halign|c>|<cwith|1|1|1|8|cell-background|pastel
        blue>|<table|<row|<cell|Document>|<cell|BPR>|<cell|BPR<rsub|1>>|<cell|BPR<rsub|2>>|<cell|COL>|<cell|COL<rsub|3>>|<cell|LN>>|<row|<cell|Total
        # of formulas>|<cell|30394>|<cell|883>|<cell|2693>|<cell|13048>|<cell|2092>|<cell|12626>>|<row|<cell|Initial
        # of errors>|<cell|2821>|<cell|63>|<cell|221>|<cell|4158>|<cell|607>|<cell|629>>|<row|<cell|#
        after correction>|<cell|705>|<cell|35>|<cell|53>|<cell|543>|<cell|37>|<cell|98>>|<row|<cell|Number
        of pages>|<cell|585>|<cell|16>|<cell|48>|<cell|357>|<cell|56>|<cell|233>>>>>|<label|corrector-1-tab>Performance
        of the <TeXmacs> syntax corrector on various documents.>
      </shown>|<\hidden*>
        <em|Demo 1>: <hlink|BPR<rsub|2>|$HOME/magix/texmacs/contrib/bpr-29-12-2010/bpr-ed2-posted2-chap2.tm>
      </hidden*>|<\hidden*>
        <em|Demo 2>: <hlink|Arxiv<rsub|1>|$HOME/magix/texmacs/arxiv/Mathematics/M4658/4685.tex>
      </hidden*>>
    </shown>|<\hidden>
      <\with|par-par-sep|0fn>
        <strong|BPR>: Algorithms in Real Algebraic Geometry (Basu, Pollack,
        Roy)

        <strong|COL>: Collection of class notes (Evan Chou)

        <strong|LN>: Transseries and Real Differential Algebra (vdH)
      </with>

      <big-table*|<block|<tformat|<cwith|1|1|1|8|cell-background|pastel
      blue>|<cwith|2|8|2|8|cell-halign|r>|<cwith|1|1|2|8|cell-halign|c>|<table|<row|<cell|Document>|<cell|BPR>|<cell|BPR<rsub|1>>|<cell|BPR<rsub|2>>|<cell|COL>|<cell|COL<rsub|3>>|<cell|LN>>|<row|<cell|Invisible
      tag correction>|<cell|92>|<cell|0>|<cell|3>|<cell|10>|<cell|5>|<cell|56>>|<row|<cell|Bracket
      matching>|<cell|676>|<cell|14>|<cell|67>|<cell|1236>|<cell|94>|<cell|282>>|<row|<cell|Bracket
      motion>|<cell|16>|<cell|0>|<cell|4>|<cell|6>|<cell|0>|<cell|4>>|<row|<cell|Superfluous
      invisible removal>|<cell|382>|<cell|1>|<cell|25>|<cell|1046>|<cell|305>|<cell|149>>|<row|<cell|Missing
      invisible insertion>|<cell|873>|<cell|11>|<cell|56>|<cell|1271>|<cell|164>|<cell|33>>|<row|<cell|Homoglyph
      substitution>|<cell|44>|<cell|2>|<cell|7>|<cell|45>|<cell|2>|<cell|6>>|<row|<cell|Miscellaneous
      corrections>|<cell|16>|<cell|0>|<cell|6>|<cell|1>|<cell|0>|<cell|1>>>>>|<label|corrector-2-tab>Numbers
      of corrections due to individual algorithms.>
    </hidden>|<\hidden>
      <\with|par-par-sep|0fn>
        <strong|BPR>: Algorithms in Real Algebraic Geometry (Basu, Pollack,
        Roy)

        <strong|COL>: Collection of class notes (Evan Chou)

        <strong|HAB>: Habilitation (vdH)
      </with>

      <\big-table*|<block|<tformat|<cwith|2|8|2|5|cell-halign|r>|<cwith|1|1|2|5|cell-halign|c>|<cwith|1|1|1|5|cell-background|pastel
      blue>|<cwith|2|8|4|4|cell-halign|r>|<cwith|1|1|4|4|cell-halign|c>|<cwith|1|1|4|4|cell-background|pastel
      blue>|<table|<row|<cell|Document>|<cell|BPR<rsub|1>>|<cell|COL<rsub|3>>|<cell|HAB<rsub|1>>|<cell|HAB<rsub|5>>>|<row|<cell|Invisible
      operator confusion>|<cell|some>|<cell|many>|<cell|>|<cell|some>>|<row|<cell|Informal
      list notation>|<cell|several>|<cell|>|<cell|several>|<cell|some>>|<row|<cell|Non
      marked text inside formulas>|<cell|several>|<cell|many>|<cell|>|<cell|>>|<row|<cell|Non
      marked formulas inside text>|<cell|some>|<cell|>|<cell|>|<cell|>>|<row|<cell|Misinterpreted
      meaningful whitespace>|<cell|>|<cell|>|<cell|several>|<cell|>>|<row|<cell|Miscellaneous
      misinterpretations>|<cell|>|<cell|some>|<cell|>|<cell|>>>>>>
        <label|misinterpret-tab>Manual determination of common sources of
        misinterpretation.
      </big-table*>
    </hidden>>
  </hidden>|<\hidden>
    <tit|Parsing informal mathematics>

    <\with|par-par-sep|0.3333fn>
      <unroll|<\shown>
        <\folded-std>
          <vspace*|0.5fn><strong|What kind of Parser?>
        <|folded-std>
          Packrat parsers are fast (<math|O<around*|(|n*s|)>> parsing,
          <math|n>: #input, <math|s>: #grammar)

          Packrat parsers are flexible (no preprocessing required)

          Packrat parsers are general (better set of recognized languages)
        </folded-std>
      </shown>|<\hidden*>
        <\folded-std>
          <vspace*|0.5fn><strong|What kind of grammar?>
        <|folded-std>
          Non-structured string grammar <math|\<Rightarrow\>> flattening of
          structured texts

          Universal grammar for mathematics

          Might support other grammars for (<abbr|e.g.>) automatic theorem
          provers
        </folded-std>
      </hidden*>|<\hidden*>
        <\folded-std>
          <vspace*|0.5fn><strong|How to allow for customization?>
        <|folded-std>
          Exploit <TeXmacs> built-in macro system

          Allow for ``behaves as'' annotations
        </folded-std>
      </hidden*>>
    </with>
  </hidden>|<\hidden>
    <tit|Snippets of the universal grammar>

    <\small>
      <unroll|<\shown>
        <\scm-code>
          (define Plus-symbol

          \ \ (:type infix)

          \ \ (:penalty 30)

          \ \ (:spacing default default)

          \ \ "+" "\<less\>amalg\<gtr\>" "\<less\>oplus\<gtr\>"
          "\<less\>boxplus\<gtr\>"

          \ \ "\<less\>dotplus\<gtr\>" "\<less\>dotamalg\<gtr\>"
          "\<less\>dotoplus\<gtr\>")
        </scm-code>
      </shown>|<\hidden*>
        <\scm-code>
          (define Plus-infix

          \ \ (:operator associative)

          \ \ (Plus-infix Post)

          \ \ (Pre Plus-infix)

          \ \ Plus-symbol)
        </scm-code>
      </hidden*>|<\hidden*>
        <\scm-code>
          (define Pre

          \ \ (:selectable inside)

          \ \ (:\<less\>lsub Script :\<gtr\>)

          \ \ (:\<less\>lsup Script :\<gtr\>)

          \ \ (:\<less\>lprime (* Prime-symbol) :\<gtr\>))

          \;

          (define Post

          \ \ (:selectable inside)

          \ \ (:\<less\>rsub Script :\<gtr\>)

          \ \ (:\<less\>rsup Script :\<gtr\>)

          \ \ (:\<less\>rprime (* Prime-symbol) :\<gtr\>))
        </scm-code>
      </hidden*>|<\hidden*>
        <\scm-code>
          (define Sum

          \ \ (Sum Plus-infix Product)

          \ \ (Sum Minus-infix Product)

          \ \ Sum-prefix)
        </scm-code>
      </hidden*>>
    </small>
  </hidden>|<\hidden>
    <tit|How much structure in the document?>

    <\with|par-par-sep|0.3333fn>
      <\description>
        <unroll|<\shown>
          <vspace*|1fn><item*|Brackets>

          Previously: no structure in document<htab|5mm><math|f(x+y)+a*(b+c)>

          Currently: <markup|around> tag<htab|5mm><math|f<around*|(|x+y|)>+a*<around*|(|b+c|)>>
        </shown>|<\hidden*>
          <vspace*|0.5fn><item*|Subscripts and superscripts>

          Base not in document

          <\indent>
            <math|\<hookrightarrow\>> either requires parsing or hard to edit
          </indent>

          Scripts physically glued to content on direct
          left<htab|5mm><math|<with|math-display|true|a+lim<rsub|i\<rightarrow\>\<infty\>>
          x<rsub|i>>>
        </hidden*>|<\hidden*>
          <vspace*|0.5fn><item*|Big operators>

          Scope not in document

          Prefix operators, arguments variable
          priorities<htab|5mm><math|<with|math-display|true|<big|sum><rsub|i=1><rsup|n>a<rsub|i>+<big|sum><rsub|i=1><rsup|p>b<rsub|i>*c<rsub|i>>>
        </hidden*>>
      </description>
    </with>
  </hidden>|<\hidden>
    <tit|Grammar rules for big operators>

    <\small>
      <\scm-code>
        (define Big-sum-symbol

        \ \ "int" "oint" "intlim" "ointlim" "sum" "oplus" "triangledown")

        \;

        (define Big-sum

        \ \ (:operator)

        \ \ (Big-sum Post)

        \ \ (:\<less\>big Big-sum-symbol :\<gtr\>))

        \;

        (define Prefixed

        \ \ (Big-separator Expression)

        \ \ (Big-or Conjunction)

        \ \ (Big-and Negation)

        \ \ (Big-union Intersection)

        \ \ (Big-intersection Sum)

        \ \ (Big-sum Sum-prefix)

        \ \ (Big-product Power)

        \ \ (Prefix-prefix Prefixed)

        \ \ (Pre Prefixed)

        \ \ (Postfixed Space-infix Prefixed)

        \ \ Postfixed)
      </scm-code>
    </small>
  </hidden>|<\hidden>
    <tit|Customization>

    <\description>
      <unroll|<\shown>
        <vspace*|0.5fn><item*|``Behaves as'' annotation>

        <\equation*>
          a<rsub|1>+\<cdots\>\<cdots\>+a<rsub|n>
        </equation*>
      </shown>|<\hidden*>
        <item*|Macro expansion>

        <\small>
          <\tm-fragment>
            <inactive*|<assign|pt|<macro|<math-times|<superpose|+|\<times\>>>>>>
          </tm-fragment>
        </small>

        <\equation*>
          a<pt>b+x<pt>y
        </equation*>
      </hidden*>|<\hidden*>
        <item*|Customizing the interface>

        <\session|scheme|default>
          <\input|Scheme] >
            (kbd-map (:mode in-math?) ("+ *" (make 'pt)))
          </input>

          <\input|Scheme] >
            \;
          </input>
        </session>
      </hidden*>>
    </description>

    \;
  </hidden>|<\hidden>
    <tit|Non parsable formulas>

    <\with|par-par-sep|0.3333fn>
      <\description>
        <unroll|<\shown>
          <item*|Meaningful whitespace or text>

          <center|<math|<tabular*|<tformat|<table|<row|<cell|<label|incorrect-meaningful-whitespace>\<exists\>x<space|1em>P<around*|(|x|)>>>|<row|<cell|<around*|{|b\<less\>\<bbb-N\><rsub|0><mid|\|>b\<less\>d<text|
          and ><frac|det A|d>*\<bbb-Z\>+b*\<bbb-Z\>+d*\<bbb-Z\>=\<frak-d\><rsub|1><around*|(|A|)>|}>>>>>>>>
        </shown>|<\hidden*>
          <item*|Using mathematics as a replacement for text>

          <center|<math|a)\<Rightarrow\>b)>>
        </hidden*>|<\hidden*>
          <item*|Manual hyphenation on tables>

          <center|<math|<tabular*|<tformat|<cwith|1|-1|3|3|cell-halign|l>|<table|<row|<cell|posgcd<around|(|<with|math-font|cal|P>\<cup\><around|{|P|}>|)>>|<cell|=>|<cell|{<around|(|Pol<around|(|p<around|(|L|)>|)>,<with|math-font|cal|C>\<wedge\><with|math-font|cal|C><rsub|L>|)>\<mid\>(Q,<with|math-font|cal|C)>\<in\>posgcd(<with|math-font|cal|P)>>>|<row|<cell|>|<cell|>|<cell|<text|and
          >L<text| leaf of >TRems<around|(|P,Q|)>}.<label|table-concat-ex>>>>>>>>
        </hidden*>|<\hidden*>
          <item*|Unsuccessful automatic correction>

          <center|<tabular*|<tformat|<table|<row|<cell|<math|<with|math-font-shape|right|T><rsup|j><rsub|\<ast\>>\<nu\>>>>|<row|<cell|<verbatim|<with|color|dark
          grey|$>a+<with|color|dark grey|$> <with|color|dark
          grey|$>b<with|color|dark grey|$>>>>|<row|<cell|<math|<with|math-font|cal|B>=<around*|{|a+i*b\<mid\><around*|\||b|\|>\<leqslant\>\<um\><sqrt|3>*a|}>>>>>>>>
        </hidden*>|<\hidden*>
          <item*|Non standard operator precedence>

          <center|Given a formula <math|\<Theta\><around|(|Y|)>=<around|(|\<exists\>X|)><space|0.75spc>\<cal-B\><around|(|X,Y|)>>,
          where<nbsp><math|\<cal-B\>> is...>
        </hidden*>|<\hidden*>
          <vspace*|0.5fn><item*|Abusive visual twiddling>

          <center|<math|<with|math-display|true|<big|prod><rsub|<rsup|<stack|<tformat|<table|<row|<cell|i\<less\>j,<space|0.25spc>k\<less\>\<ell\>>>|<row|<cell|<around|(|i,j|)>\<less\><around|(|k,\<ell\>|)>>>>>>>><around|(|\<alpha\><rsub|i,j,k,\<ell\>>+Z*\<beta\><rsub|i,j,k,\<ell\>>|)><rsup|2>>>>
        </hidden*>|<\hidden*>
          <item*|Visual twiddling with no obvious alternative>

          <\enumerate>
            <item>The signs of the polynomials in the Sturm sequence are
            <math|+-+-+>

            <item>No other code word is of the form
            <math|0.z<rsub|1>\<ldots\>z<rsub|l<around|(|x|)>>\<ast\>\<ldots\>>

            <item><math|g=\<mathe\><rsup|<sqrt|x>+\<mathe\><rsup|<sqrt|log
            x>+\<mathe\><rsup|<sqrt|log log x>+\<udots\>\<ddots\>+log log log
            x>+log log x>+log x>>
          </enumerate>
        </hidden*>>
      </description>
    </with>
  </hidden>|<\hidden>
    <tit|Incorrectly parsed formulas>

    <\with|par-par-sep|0.3333fn>
      <\description>
        <unroll|<\shown>
          <item*|Incorrect invisible operators>

          <\enumerate>
            <item><math|b<around*|(|12*c+a<rsup|2>|)>>

            <item><math|<op|\<sim\>> <math-ss|R><around|(|n|)>*s>
          </enumerate>
        </shown>|<\hidden*>
          <vspace*|0.5fn><item*|Informal list notation>

          <\enumerate>
            <item><math|SRemS<around|(|P,Q|)>=SRemS<rsub|0><around|(|P,Q|)>,\<ldots\>,SRemS<rsub|k><around|(|P,Q|)>>

            <item>The subsets of affine spaces <math|\<bbb-R\><rsup|n>> for
            <math|n=0,1,2,\<ldots\>> that are...

            <item><math|H<around|(|Y<rsub|i>\|Y<rsup|i-1>,X<rsup|n>|)>>
          </enumerate>
        </hidden*>|<\hidden*>
          <vspace*|0.5fn><item*|Non marked text inside formulas>

          <math|<math|p<around|(|<wide|x|^>\|x|)>=1 if <wide|x|^>=0>>
        </hidden*>|<\hidden*>
          <vspace*|0.5fn><item*|Misinterpretation of meaningful whitespace>

          <math|P<around|(|f|)>=0<space|2em><around|(|f\<prec\>\<frak-V\>|)>.>
        </hidden*>|<\hidden*>
          <vspace*|0.5fn><item*|Miscellaneous misinterpretations>

          <math|<with|math-display|true|max<rsub|p,q,r>-1-p*log p-q*log
          q-r*log r-<around|(|1-p-q-r|)>*log<around|(|1-p-q-r|)>>>
        </hidden*>>
      </description>
    </with>
  </hidden>|<\hidden>
    <tit|Semantic selections>

    <\description>
      <unroll|<\shown>
        <vspace*|0.5fn><item*|Selectable subexpressions>

        <\with|par-par-sep|0.3333fn>
          <unroll|<\shown>
            Associative operators

            <\equation*>
              a+b-c+d
            </equation*>
          </shown>|<\hidden*>
            Selections as unary operators when pasting

            <\equation*>
              <tabular*|<tformat|<table|<row|<cell|+a+b>|<cell|>|<cell|<with|color|black|\<leftrightsquigarrow\>>>|<cell|>|<cell|x\<longmapsto\>x+a+b>>>>>
            </equation*>
          </hidden*>|<\hidden*>
            Second example

            <\equation*>
              <tabular|<tformat|<table|<row|<cell|<frac|1|1+>>|<cell|>|<cell|<with|color|black|\<leftrightsquigarrow\>>>|<cell|>|<cell|x\<longmapsto\><frac|1|1+x>>>>>>
            </equation*>
          </hidden*>>
        </with>
      </shown>|<\hidden*>
        <vspace*|0.5fn><item*|Problematic transformations>

        <\with|par-par-sep|0.3333fn>
          <\equation*>
            <tabular|<tformat|<table|<row|<cell|a<rsub|1>,\<ldots\>,a<rsub|n>\<in\>A>|<cell|>|<cell|<with|color|black|\<rightsquigarrow\>>>|<cell|>|<cell|<around*|(|a<rsub|1>,\<ldots\>,a<rsub|n>|)>\<in\>A>>>>>
          </equation*>
        </with>
      </hidden*>>
    </description>

    <\equation*>
      \;
    </equation*>
  </hidden>|<\hidden>
    <tit|Semantic typesetting>

    <\description>
      <unroll|<\shown>
        <vspace*|0.5fn><item*|Spacing>

        <\enumerate>
          <item>Binary subtraction <math|x-y>

          <item>Unary negation <math|-x>

          <item>Abstract operators <math|\<box\>\<in\><around|{|+,-,\<cdot\>|}>>
        </enumerate>
      </shown>|<\hidden*>
        <vspace*|0.5fn><item*|Hyphenation transforms>

        <\eqnarray*>
          <tformat|<table|<row|<cell|<frac|a+b+c|x+y+z>>|<cell|<with|color|black|\<rightsquigarrow\>>>|<cell|<around*|(|a+b+c|)>/<around*|(|x+y+z|)>>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|<frac|1|a+b+c+x+y+z>>|<cell|<with|color|black|\<rightsquigarrow\>>>|<cell|1/<around*|(|a+b+c+x+y+z|)>>>>>
        </eqnarray*>
      </hidden*>>
    </description>
  </hidden>>
</body>

<\initial>
  <\collection>
    <associate|info-flag|none>
    <associate|language|english>
    <associate|page-screen-top|5mm>
    <associate|sfactor|5>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|Taylor|<tuple|1|?>>
    <associate|auto-1|<tuple|Miscellaneous corrections|?>>
    <associate|auto-2|<tuple|Miscellaneous corrections|?>>
    <associate|auto-3|<tuple|Miscellaneous corrections|?>>
    <associate|auto-4|<tuple|1|?>>
    <associate|auto-5|<tuple|1|?>>
    <associate|comp-props|<tuple|1|?>>
    <associate|corrector-1-tab|<tuple|Miscellaneous corrections|?>>
    <associate|corrector-2-tab|<tuple|Miscellaneous corrections|?>>
    <associate|incorrect-meaningful-whitespace|<tuple|Meaningful whitespace
    or text|?>>
    <associate|misinterpret-tab|<tuple|Miscellaneous corrections|?>>
    <associate|posfig|<tuple|7|?>>
    <associate|table-concat-ex|<tuple|Manual hyphenation on tables|?>>
    <associate|tfin-t-bound|<tuple|1|?>>
    <associate|trlagr|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|ts-diff1|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|ts-diff2|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|ts-euler|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|ts-gamma|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|ts-transfin|<tuple|1|?>>
    <associate|ts-zeta|<tuple|1|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|table>
      <tuple|normal|<label|corrector-1-tab>Performance of the
      T<rsub|<space|-0.4spc><move|<resize|<with|math-level|<quote|0>|E>||||0.5fn>|0fn|-0.1fn>><space|-0.4spc>X<rsub|<space|-0.4spc><move|<resize|M<space|-0.2spc>A<space|-0.4spc>CS||||0.5fn>|0fn|-0.1fn>>
      syntax corrector on various documents.|<pageref|auto-1>>

      <tuple|normal|<label|corrector-2-tab>Numbers of corrections due to
      individual algorithms.|<pageref|auto-2>>

      <\tuple|normal>
        <label|misinterpret-tab>Manual determination of common sources of
        misinterpretation.
      </tuple|<pageref|auto-3>>
    </associate>
  </collection>
</auxiliary>